
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>


#ifdef MACZIP

#include "osdep.h"
#include "macglob.h"

extern int noisy;
extern char MacPathEnd;
extern char *zipfile;   /* filename of the Zipfile */
extern char *tempzip;	/* Temporary zip file name */
extern MacZipGlobals	MacZip;
#endif

#include "macstuff.h"
#include "helpers.h"
#include "pathname.h"
#include "unixlike.h"

static char			argStr[NAME_MAX];
static char 		*argv[MAX_ARGS + 1];


typedef union
{
	char 	c[4];
	OSType 	Integer;
} FinderTypeCreator;





 /* Copy a C string to a Pascal string */
unsigned char *CToPCpy(unsigned char *pstr,char *cstr)                
{
  register char *dptr, len;

        len=0;
        dptr=(char *)pstr+1;
        while (len<255 && (*dptr++ = *cstr++)!=0) ++len;
        *pstr=len;
  return pstr;
}



 /* Copy a PASCAL string to a C string */
char *PToCCpy(unsigned char *pstr,char *cstr)                
{
strncpy(cstr,(char *) &pstr[1], *pstr);
cstr[pstr[0]] = 0x00;   /* set endmarker for c-string */
return cstr;
}



char *StrCalloc(short size)
{
char *strPtr = NULL;

if ((strPtr = calloc(size, sizeof(char) )) == NULL)
	printerr("StrCalloc failed:",-1,size,__LINE__,__FILE__,"");
									
return strPtr;
}



char *StrFree(char *strPtr)
{
if (strPtr != NULL) 
	{
	free(strPtr);
	return NULL;
	}					
	
return NULL; /* make the compiler happy */
}


#ifdef MACZIP
void PrintFileInfo(void)
{
FinderTypeCreator	Type;
FinderTypeCreator	Creator;
char CTime[50], MTime[50], BTime[50];

Type.Integer 	= MacZip.fpb.hFileInfo.ioFlFndrInfo.fdType;
Creator.Integer = MacZip.fpb.hFileInfo.ioFlFndrInfo.fdCreator;

strftime(CTime,sizeof(CTime), "%m/%d/%y  %H:%M:%S", localtime(&MacZip.CreatDate));
strftime(MTime,sizeof(MTime), "%m/%d/%y  %H:%M:%S", localtime(&MacZip.ModDate));
strftime(BTime,sizeof(BTime), "%m/%d/%y  %H:%M:%S", localtime(&MacZip.BackDate));

printf("\n\n-------------------------------------------------------------------------------");
printf("\n FullPath Name =                   [%s]",  MacZip.FullPath);
printf("\n File Attributes =                  %s  0x%x  %d", sBit2Str(MacZip.fpb.hFileInfo.ioFlAttrib), MacZip.fpb.hFileInfo.ioFlAttrib, MacZip.fpb.hFileInfo.ioFlAttrib);
printf("\n Enclosing Folder ID# =             0x%x  %d",  MacZip.fpb.hFileInfo.ioFlParID,  MacZip.fpb.hFileInfo.ioFlParID);

if (!MacZip.isDirectory)
{
printf("\n File Type =                        [%c%c%c%c]  0x%lx", Type.c[0],Type.c[1],Type.c[2],Type.c[3], MacZip.fpb.hFileInfo.ioFlFndrInfo.fdType);
printf("\n File Creator =                     [%c%c%c%c]  0x%lx",Creator.c[0],Creator.c[1],Creator.c[2],Creator.c[3] , MacZip.fpb.hFileInfo.ioFlFndrInfo.fdCreator);
printf("\n Data Fork :" );
printf("\n    Actual (Logical) Length =       %d  0x%x ", MacZip.fpb.hFileInfo.ioFlLgLen, MacZip.fpb.hFileInfo.ioFlLgLen);
printf("\n    Allocated (Physical) Length =   %d  0x%x", MacZip.fpb.hFileInfo.ioFlPyLen, MacZip.fpb.hFileInfo.ioFlPyLen);
printf("\n Resource Fork :" );
printf("\n    Actual (Logical) Length =       %d  0x%x", MacZip.fpb.hFileInfo.ioFlRLgLen, MacZip.fpb.hFileInfo.ioFlRLgLen );
printf("\n    Allocated (Physical) Length =   %d  0x%x", MacZip.fpb.hFileInfo.ioFlRPyLen, MacZip.fpb.hFileInfo.ioFlRPyLen );
}

printf("\n Dates :                GMT-Offset: %2.2f hours  %d sec;", (float) MacZip.gmt_offset / (float) (60*60) ,MacZip.gmt_offset);

printf("\n    Created =                       %s  ", CTime);
printf("\n    Modified =                      %s  ", MTime);
printf("\n    Backup =                        %s  ", BTime);

if (!MacZip.isDirectory)
{
printf("\n Finder Flags :                     %s  0x%x  %d",sBit2Str(MacZip.fpb.hFileInfo.ioFlFndrInfo.fdFlags), MacZip.fpb.hFileInfo.ioFlFndrInfo.fdFlags, MacZip.fpb.hFileInfo.ioFlFndrInfo.fdFlags);
printf("\n Finder Icon Position =          X: %d  0x%x ", MacZip.fpb.hFileInfo.ioFlFndrInfo.fdLocation.h, MacZip.fpb.hFileInfo.ioFlFndrInfo.fdLocation.h);
printf("\n                                  Y: %d  0x%x ", MacZip.fpb.hFileInfo.ioFlFndrInfo.fdLocation.v, MacZip.fpb.hFileInfo.ioFlFndrInfo.fdLocation.v);
} 
else
{
printf("\n Finder Flags :                     %s  0x%x  %d",sBit2Str(MacZip.fpb.dirInfo.ioDrUsrWds.frFlags), MacZip.fpb.dirInfo.ioDrUsrWds.frFlags, MacZip.fpb.dirInfo.ioDrUsrWds.frFlags);
printf("\n Finder Icon Position =          X: %d  0x%x ", MacZip.fpb.dirInfo.ioDrUsrWds.frLocation.h, MacZip.fpb.dirInfo.ioDrUsrWds.frLocation.h);
printf("\n                                  Y: %d  0x%x ", MacZip.fpb.dirInfo.ioDrUsrWds.frLocation.v, MacZip.fpb.dirInfo.ioDrUsrWds.frLocation.v);
}

printf("\n-------------------------------------------------------------------------------\n");
}


char *sBit2Str(unsigned short value)
{
short pos = 0;
static char str[sizeof(value)*8];

memset(str,'0',sizeof(value)*8);   /* set string-buffer */

for (pos = sizeof(value)*8; pos != 0; value >>= 1)
	{
	if (value & 01)
		str[pos] = '1';
	else str[pos] = '0';
	pos--;
	}

str[(sizeof(value)*8)+1] = 0x00;
return str;
}





void print_extra_info(void)
{
FinderTypeCreator	Type;
FinderTypeCreator	Creator;

Type.Integer 	= MacZip.fpb.hFileInfo.ioFlFndrInfo.fdType;
Creator.Integer = MacZip.fpb.hFileInfo.ioFlFndrInfo.fdCreator;

printf("\t  [%c%c%c%c] [%c%c%c%c]", Type.c[0],Type.c[1],Type.c[2],Type.c[3],
									Creator.c[0],Creator.c[1],Creator.c[2],Creator.c[3]);
}



Boolean IsZipFile(char *filen)
{

if 	(stricmp(filen,MacZip.ZipFullPath) == 0) return true;
else return false;

}

#endif  /* #ifdef MACZIP */




int ParseArguments(char *s, char ***arg)
{
	int  n = 1, Quote = 0;
	char *p = s, *p1, c;
	
	argv[0] = GetAppName();
	
	*arg = argv;
	
	p1 = (char *) argStr;
	while ((c = *p++) != 0) {
		if (c==' ') continue;
		argv[n++] = p1;
		if (n > MAX_ARGS)				/* mm 970404 */
			return (n-1);				/* mm 970404 */
		do {
			if (c=='\\' && *p++) 
				c = *p++;
			else
				if ((c=='"') || (c == '\'')) {
					if (!Quote) {
						Quote = c;
						continue;
					}
					if (c == Quote) {
						Quote = 0;
						continue;
					}
				}
			*p1++ = c;
		} while (*p && ((c = *p++) != ' ' || Quote));
		*p1++ = 0;
	}
	return n;	
}




void PrintArguments(int argc,char **argv)
{
#ifdef MACZIP
if (!noisy) return;
#endif

printf("\n Arguments:");
printf("\n --------------------------");

while(--argc >= 0)
	printf("\n argc: %d  argv: [%s]",argc, &*argv[argc]);
	
printf("\n --------------------------\n\n");
return;
}











int PrintUserHFSerr(int cond, int err, char *msg2)
{
char *msg;

if (cond != 0)
	{
	switch (err)
		{
	     case -35:
	     	msg = "No such Volume";
	     break;
	
	     case -56:
	     	msg = "No such Drive";
	     break;

	     case -37:
	     	msg = "Bad Volume Name";
	     break;
	     
	     case -43:
	     	msg = "Directory/File not found";
	     break;
	     
	     case -120:
	     	msg = "Directory/File not found or incomplete pathname";
	     break;

		default: return err;
	     }
	fprintf(stderr,"\n\n Error: %s ->%s", msg, msg2);
	exit(err);
	}
	
return 0;
}




short CheckMountedVolumes(char *FullPath)
{
FSSpec	volumes[50];		/* 50 Volumes should be enough */
char VolumeName[257], volume[257];
short actVolCount, volIndex = 1, VolCount = 0;
OSErr err;
int i;

GetVolumeFromPath(FullPath,VolumeName);

err = OnLine(volumes, 50, &actVolCount, &volIndex); 
printerr("OnLine:",(err != -35) && (err != 0),err,__LINE__,__FILE__,"");

for (i=0; i < actVolCount; i++)
	{
	PToCCpy(volumes[i].name,volume);
	if (stricmp(volume,VolumeName) == 0) VolCount++;
	}
printerr("OnLine:",(VolCount == 0) ,VolCount,__LINE__,__FILE__," should be at least 1");

return VolCount;
}





/* compares strings, ignoring differences in case */

int stricmp(const char *p1, const char *p2)
{
int diff;

while(*p1 && *p2)
	{
	if (*p1 != *p2)
		{
		if (isalpha(*p1) && isalpha(*p2))
			{
			diff = toupper(*p1) - toupper(*p2);
			if (diff) return diff;
			}
			else break;
		}
		p1++;
		p2++;
	}
return *p1 - *p2;
}




