/*
 *      Directory Operations for Mac based on BSD 4.3   <macdir.h>
 *      By Jason Linhart, January 1997
 */

#ifndef _UNIXLIKE_H
#define _UNIXLIKE_H       1

#include "macstuff.h"
#include <stat.h>

#define NAME_MAX 	1024

#define S_ISUID		0004000
#define S_ISGID		0002000

#define S_IRUSR		00400
#define S_IWUSR		00200
#define S_IXUSR		00100
#define S_IRWXU		(S_IRUSR | S_IWUSR | S_IXUSR)  /* = 00700 */

#define S_IRGRP		00040
#define S_IWGRP		00020
#define S_IXGRP		00010
#define S_IRWXG		(S_IRGRP | S_IWGRP | S_IXGRP)  /* = 00070 */

#define S_IROTH		00004
#define S_IWOTH		00002
#define S_IXOTH		00001
#define S_IRWXO		(S_IROTH | S_IWOTH | S_IXOTH)  /* = 00007 */

/* historical file modes */
#define	S_IREAD		00400
#define	S_IWRITE	00200
#define	S_IEXEC		00100


#define isatty(arg) 1


#define	EINVAL		22		    /* Invalid argument */
#define	ENAMETOOLONG	63		/* File name too long */


struct dirent {
        char            d_name[NAME_MAX];
};

/*
 * The following definitions are usually found if fcntl.h.
 * However, MetroWerks has screwed that file up a couple of times
 * and all we need are the defines.
 */
#define O_RDWR	  0x0		/* open the file in read/write mode */
#define O_RDONLY  0x1		/* open the file in read only mode */
#define O_WRONLY  0x2		/* open the file in write only mode */
#define O_APPEND  0x0100	/* open the file in append mode */
#define O_CREAT	  0x0200	/* create the file if it doesn't exist */
#define O_EXCL	  0x0400	/* if the file exists don't create it again */
#define O_TRUNC	  0x0800	/* truncate the file after opening it */


int MacStat (char *path, struct stat *buf);

int chmod(char *path, int mode);


#endif /* _UNIXLIKE_H  */